Class: Gem::PlatformMismatch

Inherits:
ErrorReason show all
Defined in:
lib/rubygems/errors.rb

Overview

Generated when trying to lookup a gem to indicate that the gem was found, but that it isn't usable on the current platform.

fetch and install read these and report them to the user to aid in figuring out why a gem couldn't be installed.

Instance Attribute Summary collapse

Instance Method Summary collapse

Constructor Details

#initialize(name, version) ⇒ PlatformMismatch


121
122
123
124
125
# File 'lib/rubygems/errors.rb', line 121

def initialize(name, version)
  @name = name
  @version = version
  @platforms = []
end

Instance Attribute Details

#nameObject (readonly)

the name of the gem


111
112
113
# File 'lib/rubygems/errors.rb', line 111

def name
  @name
end

#platformsObject (readonly)

The platforms that are mismatched


119
120
121
# File 'lib/rubygems/errors.rb', line 119

def platforms
  @platforms
end

#versionObject (readonly)

the version


115
116
117
# File 'lib/rubygems/errors.rb', line 115

def version
  @version
end

Instance Method Details

#add_platform(platform) ⇒ Object

append a platform to the list of mismatched platforms.

Platforms are added via this instead of injected via the constructor so that we can loop over a list of mismatches and just add them rather than perform some kind of calculation mismatch summary before creation.


133
134
135
# File 'lib/rubygems/errors.rb', line 133

def add_platform(platform)
  @platforms << platform
end

#wordyObject

A wordy description of the error.


139
140
141
142
143
144
145
# File 'lib/rubygems/errors.rb', line 139

def wordy
  "Found %s (%s), but was for platform%s %s" %
    [@name,
     @version,
     @platforms.size == 1 ? '' : 's',
     @platforms.join(' ,')]
end